Adding upstream version 1.81+debian. upstream/1.81+debian
authorDaniel Baumann <daniel@debian.org>
Sun, 18 Apr 2010 16:45:15 +0000 (18:45 +0200)
committerDaniel Baumann <daniel@debian.org>
Sun, 18 Apr 2010 16:45:15 +0000 (18:45 +0200)
15 files changed:
bin/casper-getty [new file with mode: 0755]
bin/casper-login [new file with mode: 0755]
bin/casper-reconfigure
bin/casper-snapshot [new file with mode: 0755]
casper.conf
hooks/casper
scripts/casper
scripts/casper-bottom/10adduser
scripts/casper-bottom/14locales
scripts/casper-bottom/19keyboard
scripts/casper-bottom/20xconfig
scripts/casper-bottom/22screensaver
scripts/casper-bottom/23networking
scripts/casper-bottom/31disable_update_notifier
scripts/casper-helpers [new file with mode: 0644]

diff --git a/bin/casper-getty b/bin/casper-getty
new file mode 100755 (executable)
index 0000000..f885fa9
--- /dev/null
@@ -0,0 +1,15 @@
+#! /bin/sh
+
+autologin=1
+for opt in "$@" ; do
+        if [ "$opt" = "-l" -o "$opt" = "-n" ] ; then
+                autologin=0
+        fi
+done
+
+if [ "$autologin" = "1" ] ; then
+         exec /sbin/getty -n -l /sbin/casper-login $*
+else
+         exec /sbin/getty $*
+fi
+
diff --git a/bin/casper-login b/bin/casper-login
new file mode 100755 (executable)
index 0000000..e6a4173
--- /dev/null
@@ -0,0 +1,6 @@
+#! /bin/sh
+
+USERNAME=root
+[ -f /etc/casper.conf ] && . /etc/casper.conf
+exec /bin/login -f $USERNAME
+
index ccae2c5..4e29768 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/sh
+#! /bin/sh
 
 set -e
 export PATH=/usr/bin:/usr/sbin:/sbin:/bin
diff --git a/bin/casper-snapshot b/bin/casper-snapshot
new file mode 100755 (executable)
index 0000000..e912493
--- /dev/null
@@ -0,0 +1,299 @@
+#! /bin/bash
+
+# casper-snapshot - utility to manage Debian Live systems snapshots
+#
+#   This program mount a device (fallback to /tmpfs under /mnt/snapshot
+#   and save the /cow (or a different dir) filesystem in it for reusing
+#   in another casper session. Look at manpage for more info.
+#
+# Copyright (C) 2006 Marco Amadori <marco.amadori@gmail.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#
+# On Debian systems, the complete text of the GNU General Public License
+# can be found in /usr/share/common-licenses/GPL file.
+
+PROGRAM="`basename $0`"
+VERSION=0.0.1
+
+
+# Source casper conf
+if [ -e /etc/casper.conf ]; then
+       . /etc/casper.conf
+else
+       USERNAME=$(cat /etc/passwd | grep "999" | cut -f1 -d ':')
+       HOSTNAME=$(hostname)
+       BUILD_SYSTEM="Debian"
+fi
+
+export USERNAME USERFULLNAME HOSTNAME BUILD_SYSTEM
+
+# Source helper functions
+helpers="/usr/share/initramfs-tools/scripts/casper-helpers"
+if [ -e "${helpers}" ]; then
+       . "${helpers}"
+else
+       echo "Error: I cannot found helper functions \"${helpers}\"."
+       exit 1
+fi
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+MOUNTP=""
+COW=""
+DEV=""
+DEST=""
+TYPE=""
+DESKTOP_LINK=""
+
+Header ()
+{
+       echo "${PROGRAM} - utility to do Debian Live snapshots"
+       echo
+       echo "Usage: ${PROGRAM} [-c|--cow DIRECTORY] [-d|--device DEVICE] [-o|--output FILE] [-t|--type TYPE]"
+       echo "Usage: ${PROGRAM} [-r|--resync-string STRING]"
+       echo "Usage: ${PROGRAM} [-h|--help]"
+       echo "Usage: ${PROGRAM} [-u|--usage]"
+       echo "Usage: ${PROGRAM} [-v|--version]"
+}
+
+Usage ()
+{
+       MESSAGE=${1}
+       Header
+       echo
+       echo "Try \"${PROGRAM} --help\" for more information."
+       if [ ! -z "${MESSAGE}" ]; then
+               echo -e "${MESSAGE}"
+               exit 1
+       else
+               exit 0
+       fi
+}
+
+Help ()
+{
+       Header
+       echo
+       echo "Options:"
+       echo "  -c, --cow: specifies the copy on write directory (default: /cow)."
+       echo "  -d, --device: specifies the output snapshot device (default: none)."
+       echo "  -o, --output: specifies the output image file (default: $type dependent)."
+    echo "  -r, --resync-string: internally used to resync previous made snapshots."
+       echo "  -t, --type: specifies the snapshot type between \"squashfs\", \"ext2\" or \"cpio\".gz archive (default: cpio)"
+    echo -e "\nLook at casper-snapshot(1) man page for more information."
+       exit 0
+}
+
+Version ()
+{
+       echo "${PROGRAM}, version ${VERSION}"
+       echo
+       echo "Copyright (C) 2006 Marco Amadori <marco.amadori@gmail.com>"
+       echo
+       echo "This program is free software; you can redistribute it and/or modify"
+       echo "it under the terms of the GNU General Public License as published by"
+       echo "the Free Software Foundation; either version 2 of the License, or"
+       echo "(at your option) any later version."
+       echo
+       echo "This program is distributed in the hope that it will be useful,"
+       echo "but WITHOUT ANY WARRANTY; without even the implied warranty of"
+       echo "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the"
+       echo "GNU General Public License for more details."
+       echo
+       echo "You should have received a copy of the GNU General Public License"
+       echo "along with this program; if not, write to the Free Software"
+       echo "Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA"
+       echo
+       echo "On Debian systems, the complete text of the GNU General Public License"
+       echo "can be found in /usr/share/common-licenses/GPL file."
+       echo
+       echo "Homepage: <http://live.debian.net/>"
+       exit 0
+}
+
+Do_snapshot ()
+{
+       case "${TYPE}" in
+               squashfs)
+                       echo "./tmp/exclude_list" > /tmp/exclude_list
+                       ( cd "${COW}" && find . -name '*.wh.*' >> /tmp/exclude_list )
+                       mksquashfs "${COW}" "${DEST}" -ef /tmp/exclude_list || exit 1
+                       rm /tmp/exclude_list
+                       ;;
+               cpio)
+                       ( cd "${COW}" && find . -path '*.wh.*' -prune -o -print0 | cpio --quiet -o0 -H newc | gzip -9c > "${DEST}" ) || exit 1
+                       ;;
+               ext2)
+                       DU_DIM="`du -ks ${COW} | cut -f1`"
+                       REAL_DIM="`expr ${DU_DIM} + ${DU_DIM} / 20`" # Just 5% more to be sure, need something more sophistcated here...
+                       genext2fs --size-in-blocks=${REAL_DIM} --reserved-blocks=0 --root="${COW}" "${DEST}" || exit 1
+                       ;;
+               *)
+                       echo "Internal error."
+                       exit 1
+                       ;;
+       esac
+}
+
+Is_same_mount ()
+{
+       dir1="`Base_path $1`"
+       dir2="`Base_path $2`"
+       if [ "${dir1}" == "${dir2}" ]; then
+               return 0
+       else
+               return 1
+       fi
+}
+
+Parse_args ()
+{
+       # Parse command line
+       ARGS="$1"
+       ARGUMENTS="`getopt --longoptions cow:,device:,output,resync-string:,type:,help,usage,version --name=${PROGRAM} --options c:d:o:t:r:,h,u,v --shell sh -- ${ARGS}`"
+
+       if [ "$?" != "0" ]; then
+               echo "Terminating." >&2
+               exit 1
+       fi
+
+       eval set -- "${ARGUMENTS}"
+
+       while true; do
+               case "$1" in
+                       -c|--cow)
+                               SNAP_COW="$2"; shift 2 ;;
+                       -d|--device)
+                               SNAP_DEV="$2"; shift 2 ;;
+                       -o|--output)
+                               SNAP_OUTPUT="$2"; shift 2 ;;
+                       -t|--type)
+                               SNAP_TYPE="$2"; shift 2 ;;
+                       -r|--resync-string)
+                               SNAP_RSTRING="$2"; break ;;
+                       -h|--help)
+                               Help; shift ;;
+                       -u|--usage)
+                               Usage ; shift ;;
+                       -v|--version)
+                               Version; shift ;;
+                       --)
+                               shift; break ;;
+                       *)
+                               echo "Internal error."; exit 1 ;;
+               esac
+       done
+}
+
+Mount_device ()
+{
+       dev="$1"
+
+       if [ ! -d "${MOUNTP}" ]; then
+               mkdir -p "${MOUNTP}"
+       fi
+
+       if [ -z "${dev}" ]; then
+               # create a temp
+               mount -t tmpfs -o rw tmpfs "${MOUNTP}"
+               if [ ! -L /home/$USERNAME/Desktop/casper-snapshot ]; then
+                       ln -s "${MOUNTP}" /home/$USERNAME/Desktop/casper-snapshot
+               fi
+       else
+               if [ -b "${dev}" ] ; then
+                       try_mount "${dev}" "${MOUNTP}" rw
+               fi
+       fi
+}
+
+Defaults ()
+{
+       MOUNTP="/mnt/casper-snapshot"
+       COW="/cow"
+       DEV=""
+       DEST="${MOUNTP}/casper-sn.cpio.gz"
+       TYPE="cpio"
+       DESKTOP_LINK=/home/$USERNAME/Desktop/casper-snapshot
+
+       if [ -n "${SNAP_RSTRING}" ]; then
+               COW=$(echo "${SNAP_RSTRING}" | cut -f1 -d ':')
+               DEV=$(echo "${SNAP_RSTRING}" | cut -f2 -d ':')
+               DEST=$(echo "${SNAP_RSTRING}" | cut -f3 -d ':')
+               
+               case "${DEST}" in
+                       *.cpio.gz)
+                               TYPE="cpio" ;;
+                       *.squashfs)
+                               TYPE="squashfs" ;;
+                       "")
+                               TYPE="ext2" ;;
+                       *.ext2)
+                               TYPE="ext2" ;;
+                       *)
+                               Usage "Unregognized String" ;;
+               esac
+       else
+               DEF_COW="/cow"
+               # Bad options handling
+               if [ -z "${SNAP_COW}" ]; then
+                       COW="${DEF_COW}"
+               else
+                       COW="${SNAP_COW}"
+               fi
+       
+               case "${SNAP_TYPE}" in
+                       "cpio"|"squashfs"|"ext2")
+                               TYPE="${SNAP_TYPE}"
+                               ;;
+                       "")
+                               TYPE="cpio" ;;
+                       *)
+                               Usage "Error: unrecognized snapshot type"
+                               ;;
+               esac
+               #if [ -d 
+               #if Is_same_mount 
+       fi
+
+       # check vars
+       if [ ! -d "${COW}" ]; then
+               Usage "Error: ${COW} is not a directory"
+       fi
+
+       Mount_device $DEV
+
+}
+
+Clean ()
+{
+       if [ -n "$DEV" ]; then
+               umount "${MOUNTP}"
+               rmdir "${MOUNTP}"
+               rm 
+       fi
+}
+
+Main ()
+{
+       Parse_args "$@"
+       Defaults
+       Do_snapshot
+       Clean
+}
+
+Main "$@"
index d342fdb..e56ded3 100644 (file)
@@ -1,8 +1,8 @@
 # This file should go in /etc/casper.conf
 # Supported variables are:
-# USERNAME, USERFULLNAME, HOST
+# USERNAME, USERFULLNAME, HOST, BUILD_SYSTEM
 
 export USERNAME="ubuntu"
 export USERFULLNAME="Live session user"
 export HOST="ubuntu"
-
+export BUILD_SYSTEM="Ubuntu"
index db1d405..a7ed803 100755 (executable)
@@ -34,14 +34,12 @@ copy_exec /lib/udev/vol_id /lib/udev
 copy_exec /lib/udev/path_id /lib/udev
 copy_exec /usr/bin/udevinfo /bin
 
-# cloop is needed for dmsetup
-if [ -x /sbin/dmsetup ]; then
-    manual_add_modules cloop
-
-    # Needed for devmapper
-    copy_exec /sbin/blockdev /sbin
-    copy_exec /sbin/dmsetup /sbin
-    manual_add_modules dm-snapshot
+# cifs boot
+if [ -x /sbin/mount.cifs ]; then
+    copy_exec /sbin/mount.cifs /sbin
+    for x in cifs; do
+        manual_add_modules ${x}
+    done
 fi
 
 # squashfs
@@ -66,6 +64,7 @@ manual_add_modules ohci1394
 copy_exec /usr/lib/casper/casper-md5check /bin
 
 cp /usr/share/initramfs-tools/scripts/casper-functions $DESTDIR/scripts
+cp /usr/share/initramfs-tools/scripts/casper-helpers $DESTDIR/scripts
 
 auto_add_modules net
 
index 776b57f..352cca9 100644 (file)
@@ -6,55 +6,46 @@ export PATH=/root/usr/bin:/root/usr/sbin:/root/bin:/root/sbin:/usr/bin:/usr/sbin
 
 mountpoint=/cdrom
 
-mkdir -p $mountpoint
-
-#overlay_method=unionfs
-#if [ "${DPKG_ARCH}" = "ia64" ] || [ "${DPKG_ARCH}" = "hppa" ] || [ "${DPKG_ARCH}" = "sparc" ]; then
-#    overlay_method=devmapper
-#fi
-
 USERNAME=casper
 USERFULLNAME="Live session user"
 HOST=live
+BUILD_SYSTEM=Custom
+
+mkdir -p $mountpoint
 
 [ -f /etc/casper.conf ] && . /etc/casper.conf
+export USERNAME USERFULLNAME HOST BUILD_SYSTEM
+
+. /scripts/casper-helpers
 
-export USERNAME USERFULLNAME HOST
+if [ ! -f /casper.vars ]; then
+    touch /casper.vars
+fi
 
 is_casper_path() {
     path=$1
     if [ -d "$path/casper" ]; then
-        if [ "$(echo $path/casper/*.cloop)" != "$path/casper/*.cloop" ] || 
-            [ "$(echo $path/casper/*.squashfs)" != "$path/casper/*.squashfs" ]; then
+        if [ "$(echo $path/casper/*.squashfs)" != "$path/casper/*.squashfs" ] ||
+            [ "$(echo $path/casper/*.ext2)" != "$path/casper/*.ext2" ] ||
+            [ "$(echo $path/casper/*.dir)" != "$path/casper/*.dir" ]; then
             return 0
         fi
     fi
     return 1
 }
 
-subdevices() {
-    sysblock=$1
-    r=""
-    for dev in "${sysblock}" "${sysblock}"/*; do
-        if [ -e "${dev}/dev" ]; then
-            r="${r} ${dev}"
-        fi
-    done
-    echo ${r}
-}
-
 get_backing_device() {
-       case "$1" in
-            *.cloop)
-                echo $(setup_loop "$1" "cloop" "/sys/block/cloop*")
-                       ;;
-            *.squashfs)
-                echo $(setup_loop "$1" "loop" "/sys/block/loop*")
-                ;;
-            *)
-                panic "Unrecognized casper filesystem: $1"
-                ;;
-       esac
+    case "$1" in
+        *.squashfs|*.ext2)
+            echo $(setup_loop "$1" "loop" "/sys/block/loop*")
+            ;;
+        *.dir)
+            echo "directory"
+            ;;
+        *)
+            panic "Unrecognized casper filesystem: $1"
+            ;;
+    esac
 }
 
 match_files_in_dir() {
@@ -70,124 +61,242 @@ match_files_in_dir() {
 mount_images_in_directory() {
     directory="$1"
     rootmnt="$2"
-    if match_files_in_dir "$directory/casper/*.cloop"; then
-        # Let's hope there's just one matching *.cloop... FIXME
-        setup_devmapper $(get_backing_device "$directory/casper/*.cloop") "$rootmnt"
-    elif match_files_in_dir "$directory/casper/*.squashfs"; then
+    if match_files_in_dir "$directory/casper/*.squashfs" ||
+        match_files_in_dir "$directory/casper/*.ext2" ||
+        match_files_in_dir "$directory/casper/*.dir"; then
         setup_unionfs "$directory/casper" "$rootmnt"
-    else 
+    else
         :
     fi
 }
 
-sys2dev() {
-    sysdev=${1#/sys}
-    echo "/dev/$(udevinfo -q name -p ${sysdev} 2>/dev/null|| echo ${sysdev##*/})"
+is_nice_device() {
+    sysfs_path="${1#/sys}"
+    if /lib/udev/path_id "${sysfs_path}" | grep -E -q "ID_PATH=(usb|pci-[^-]*-[ide|scsi|usb])"; then
+        return 0
+    fi
+    return 1
 }
 
-setup_loop() {
-    local fspath=$1
-    local module=$2
-    local pattern=$3
-
-    modprobe -Qb "$module"
-    udevsettle
-    for loopdev in $pattern; do
-        if [ "$(cat $loopdev/size)" -eq 0 ]; then
-            dev=$(sys2dev "${loopdev}")
-            losetup "$dev" "$fspath"
-            echo "$dev"
+is_supported_fs () {
+    # FIXME: do something better like the scan of supported filesystems
+    fstype="${1}"
+    case ${fstype} in
+        vfat|iso9660|udf|ext2|ext3|ntfs)
             return 0
-        fi
-    done
-    panic "No loop devices available"
+            ;;
+    esac
+    return 1
 }
 
-get_fstype() {
-    local FSTYPE
-    local FSSIZE
-    eval $(fstype < $1)
-    if [ "$FSTYPE" != "unknown" ]; then
-        echo $FSTYPE
-        return 0
+copy_live_to() {
+    copyfrom="${1}"
+    copytodev="${2}"
+    copyto="${copyfrom}_swap"
+
+    size=$(fs_size "" ${copyfrom} "used")
+
+    if [ "${copytodev}" = "ram" ]; then
+        # copying to ram:
+        freespace=$( expr $(awk '/MemFree/{print $2}' /proc/meminfo) + $( cat /proc/meminfo | grep Cached | head -n 1 | awk '/Cached/{print $2}' - ) )
+        mount_options="-o size=${size}k"
+        free_string="memory"
+        fstype="tmpfs"
+        dev="/dev/shm"
+    else
+        # it should be a writable block device
+        if [ -b "${copytodev}" ]; then
+            dev="${copytodev}"
+            free_string="space"
+            fstype=$(get_fstype "${dev}")
+            freespace=$(fs_size "${dev}")
+        else
+            [ "$quiet" != "y" ] && log_warning_msg "${copytodev} is not a block device."
+            return 1
+        fi
+    fi
+    if [ "${freespace}" -lt "${size}" ] ; then
+        [ "$quiet" != "y" ] && log_warning_msg "Not enough free ${free_string} (${freespace}k > ${size}k) to copy live media in ${copytodev}."
+        return 1
     fi
-    /lib/udev/vol_id -t $1 2>/dev/null
+
+    # begin copying..
+    mkdir "${copyto}"
+    echo "mount -t ${fstype} ${mount_options} ${dev} ${copyto}"
+    mount -t "${fstype}" ${mount_options} "${dev}" "${copyto}"
+    cp -a ${copyfrom}/* ${copyto} # "cp -a" from busybox also copies hidden files
+    umount ${copyfrom}
+    mount -r -o move ${copyto} ${copyfrom}
+    rmdir ${copyto}
+    return 0
 }
 
-setup_devmapper() {
-    backdev="$1"
-    rootmnt="$2"
+do_netmount() {
+    rc=1
 
-    modprobe -Qb dm-mod
-    COW_DEVICE=/dev/ram1
-    COW_NAME="casper-cow"
+    modprobe "${MP_QUIET}" af_packet # For DHCP
 
-    BACKING_FILE_SIZE=$(blockdev --getsize "$backdev")
-    MAX_COW_SIZE=$(blockdev --getsize "$COW_DEVICE")
-    CHUNK_SIZE=8 # sectors
+    ipconfig ${DEVICE} /tmp/net-${DEVICE}.conf | tee /netboot.config
 
-    if [ -z "$COW_SIZE" -o "$COW_SIZE" -gt "$MAX_COW_SIZE" ]; then
-        COW_SIZE=$MAX_COW_SIZE
+    if [ "${NFSROOT}" = "auto" ]; then
+        NFSROOT=${ROOTSERVER}:${ROOTPATH}
     fi
 
-    echo "0 $COW_SIZE linear $COW_DEVICE 0" | dmsetup create $COW_NAME
+    [ "$quiet" != "y" ] && log_begin_msg "Trying netboot from ${NFSROOT}"
 
-    echo "0 $BACKING_FILE_SIZE snapshot $backdev /dev/mapper/$COW_NAME p $CHUNK_SIZE" | \
-        dmsetup create casper-snapshot
-    if [ "$(get_fstype $backdev)" = "unknown" ]; then
-        panic "Unknown file system type on $backdev"
+    if [ "${NETBOOT}" != "nfs" ] && do_cifsmount ; then
+        rc=0
+    elif do_nfsmount ; then
+        NETBOOT="nfs"
+        export NETBOOT
+        rc=0
     fi
-    mount -t $(get_fstype "$backdev") /dev/mapper/casper-snapshot $rootmnt || panic "Can not mount /dev/mapper/casper/snapshot on $rootmnt"
 
-    mkdir -p "$rootmnt/rofs"
-    echo "0 $BACKING_FILE_SIZE linear $backdev 0" | dmsetup create casper-backing
-    mount -t $(get_fstype "$backdev") /dev/mapper/casper-backing "$rootmnt/rofs"
+    [ "$quiet" != "y" ] && log_end_msg
+    return ${rc}
 }
 
-where_is_mounted() {
-    device=$1
-    if grep -q "^$device " /proc/mounts; then
-        grep "^$device " /proc/mounts | read d mountpoint rest
-        echo $mountpoint
-        return 0
+do_nfsmount() {
+    rc=1
+    modprobe "${MP_QUIET}" nfs
+    if [ -z "${NFSOPTS}" ]; then
+        NFSOPTS=""
     fi
-    return 1
+
+    [ "$quiet" != "y" ] && log_begin_msg "Trying nfsmount -o nolock -o ro ${NFSOPTS} ${NFSROOT} ${mountpoint}"
+    # FIXME: This for loop is an ugly HACK round an nfs bug
+    for i in 0 1 2 3 4 5 6 7 8 9 a b c d e f 10 11 12 13; do
+        nfsmount -o nolock -o ro ${NFSOPTS} "${NFSROOT}" "${mountpoint}" && rc=0 && break
+        sleep 1
+    done
+    return ${rc}
 }
 
-find_cow_device() {
-    for sysblock in $(echo /sys/block/* | tr ' ' '\n' | grep -v loop); do
-        for dev in $(subdevices "${sysblock}"); do
-            devname=$(sys2dev "${dev}")
-            if [ "$(/lib/udev/vol_id -l $devname 2>/dev/null)" = "casper-rw" ]; then
-                echo "$devname"
-                return
-            elif [ "$(get_fstype ${devname})" = "vfat" ]; then
-                mkdir -p /cow-backing
-                if where_is_mounted ${devname} > /dev/null; then
-                    mount -o remount,rw ${devname} $(where_is_mounted ${devname}) || panic "Remounting failed"
-                    mount -o bind $(where_is_mounted ${devname}) /cow-backing || panic "Cannot bind-mount"
-                else
-                    mount -t $(get_fstype "${devname}") -o rw "${devname}" /cow-backing || panic "Cannot mount $devname on /cow-backing"
-                fi
+do_cifsmount() {
+    rc=1
+    if [ -x "/sbin/mount.cifs" ]; then
+        if [ -z "${NFSOPTS}" ]; then
+            CIFSOPTS="-ouser=root,password="
+        else
+            CIFSOPTS="${NFSOPTS}"
+        fi
 
-                if [ -e "/cow-backing/casper-rw" ]; then
-                    echo $(setup_loop "/cow-backing/casper-rw" "loop" "/sys/block/loop*")
-                    return 0
-                else
-                    umount /cow-backing
+        [ "$quiet" != "y" ] && log_begin_msg "Trying mount.cifs ${NFSROOT} ${mountpoint} ${CIFSOPTS}"
+        modprobe "${MP_QUIET}" cifs
+
+        if mount.cifs "${NFSROOT}" "${mountpoint}" "${CIFSOPTS}" ; then
+            rc=0
+        fi
+    fi
+    return ${rc}
+}
+
+do_snap_copy ()
+{
+    fromdev="${1}"
+    todir="${2}"
+    snap_type="${3}"
+
+    size=$(fs_size "${fromdev}" "" "used")
+
+    if [ -b "${fromdev}" ]; then
+        # look for free mem
+        if [ -n "${HOMEMOUNTED}" -a "${snap_type}" = "HOME" ]; then
+            todev=$(cat /proc/mounts | grep -s " $(base_path ${todir}) " | awk '{print $1}' )
+            freespace=$(df -k  | grep -s ${todev} | awk '{print $4}')
+        else
+            freespace=$( expr $(awk '/MemFree/{print $2}' /proc/meminfo) + $( cat /proc/meminfo | grep Cached | head -n 1 | awk '/Cached/{print $2}' - ))
+        fi
+
+        tomount="/mnt/tmpsnap"
+        if [ ! -d "${tomount}" ] ; then
+            mkdir -p "${tomount}"
+        fi
+
+        fstype=$(get_fstype "${fromdev}")
+        if [ -n "${fstype}" ]; then
+            # Copying stuff...
+            mount -t "${fstype}" -o ro "${fromdev}" "${tomount}"
+            cp -a "${tomount}"/* ${todir}
+            umount "${tomount}"
+        else
+            log_warning_msg "Unrecognized fstype: ${fstype} on ${fromdev}:${snap_type}"
+        fi
+
+        rmdir "${tomount}"
+        if echo ${fromdev} | grep -qs loop; then
+           losetup -d "${fromdev}"
+        fi
+        return 0
+    else
+        return 1
+        [ "$quiet" != "y" ] && log_warning_msg "Unable to find the snapshot ${snap_type} medium"
+    fi
+}
+
+try_snap ()
+{
+    # Look for $snap_label.* in block devices and copy the contents to $snap_mount
+    #   and remember the device and filename for resync on exit in casper.init
+
+    snap_label="${1}"
+    snap_mount="${2}"
+    snap_type="${3}"
+
+    snapdata=$(find_files "${snap_label}.squashfs ${snap_label}.cpio.gz ${snap_label}.ext2")
+    if [ ! -z "${snapdata}" ]; then
+        snapdev="$(echo ${snapdata} | cut -f1 -d ' ')"
+        snapback="$(echo ${snapdata} | cut -f2 -d ' ')"
+        snapfile="$(echo ${snapdata} | cut -f3 -d ' ')"
+        if echo "${snapfile}" | grep -qs '\(squashfs\|ext2\)'; then
+            # squashfs or ext2 snapshot
+            dev=$(get_backing_device "${snapback}/${snapfile}")
+            if ! do_snap_copy "${dev}" "${snap_mount}" "${snap_type}"; then
+                 log_warning_msg "Impossible to include the ${snapfile} Snapshot"
+                 return 1
+            fi
+        else
+            # cpio.gz snapshot
+            if ! (cd "${snap_mount}" && zcat "${snapback}/${snapfile}" | cpio -i -u -d 2>/dev/null) ; then
+                log_warning_msg "Impossible to include the ${snapfile} Snapshot"
+                return 1
+            fi
+        fi
+        umount "${snapback}"
+    else
+        dev=$(find_cow_device "${snap_label}")
+        if [ -b ${dev} ]; then
+            if echo "${dev}" | grep -qs loop; then
+                # strange things happens, user confused?
+                snaploop=$( losetup ${dev} | awk '{print $3}' | tr -d '()' )
+                snapfile=$(basename ${snaploop})
+                snapdev=$(cat /proc/mounts | awk '{print $2,$1}' | grep -es "^$( dirname ${snaploop} )" | cut -f2 -d ' ')
+            else
+                snapdev="${dev}"
+            fi
+            if ! do_snap_copy "${dev}" "${snap_mount}" "${snap_type}" ; then
+                log_warning_msg "Impossible to include the ${snap_label} Snapshot"
+                return 1
+            else
+                if [ -n "${snapfile}" ]; then
+                     # it was a loop device, user confused
+                     umount ${snapdev}
                 fi
             fi
-            
-        done
-    done
-    return 1    
+        else
+            log_warning_msg "Impossible to include the ${snap_label} Snapshot"
+            return 1
+        fi
+    fi
+    echo "export ${snap_type}SNAP="${snap_mount}":${snapdev}:${snapfile}" >> /etc/casper.conf # for resync on reboot/halt
+    return 0
 }
 
 setup_unionfs() {
     image_directory="$1"
     rootmnt="$2"
-    modprobe -Qb unionfs
+
+    modprobe "${MP_QUIET}" -b unionfs
 
     # run-init can't deal with images in a subdir, but we're going to
     # move all of these away before it runs anyway.  No, we're not,
@@ -197,43 +306,84 @@ setup_unionfs() {
     croot="/"
 
     # Let's just mount the read-only file systems first
-    mkdir -p "${croot}"
-    for image in "${image_directory}"/*.squashfs; do
-        imagename=$(basename "${image}")
-        backdev=$(get_backing_device "$image")
-        fstype=$(get_fstype "${backdev}")
-        if [ "${fstype}" = "unknown" ]; then
-            panic "Unknown file system type on ${backdev} (${image})"
-        fi
-        mkdir -p "${croot}/${imagename}"
-        mount -t "${fstype}" -o ro "${backdev}" "${croot}/${imagename}" || panic "Can not mount $backdev ($image) on ${croot}/${imagename}"
-    done
-
     rofsstring=""
-    for dir in $(mount -t squashfs | cut -d\  -f 3); do
-        rofsstring="$dir=ro:$rofsstring"
+    rofslist=""
+    if [ "${NETBOOT}" = "nfs" ] ; then
+        roopt="nfsro" # go aroung a bug in nfs-unionfs locking
+    else
+        roopt="ro"
+    fi
+
+    mkdir -p "${croot}"
+    for image_type in "ext2" "squashfs" "dir" ; do
+        for image in "${image_directory}"/*."${image_type}"; do
+            imagename=$(basename "${image}")
+            if [ -d "${image}" ]; then
+                # it is a plain directory: do nothing
+                rofsstring="${image}=${roopt}:${rofsstring}"
+                rofslist="${image} ${rofslist}"
+            elif [ -f "${image}" ]; then
+                backdev=$(get_backing_device "$image")
+                fstype=$(get_fstype "${backdev}")
+                if [ "${fstype}" = "unknown" ]; then
+                    panic "Unknown file system type on ${backdev} (${image})"
+                fi
+                mkdir -p "${croot}/${imagename}"
+                mount -t "${fstype}" -o ro "${backdev}" "${croot}/${imagename}" || panic "Can not mount $backdev ($image) on ${croot}/${imagename}" && rofsstring="${croot}/${imagename}=${roopt}:${rofsstring}" && rofslist="${croot}/${imagename} ${rofslist}"
+            fi
+        done
     done
     rofsstring=${rofsstring%:}
 
     mkdir -p /cow
-    
-    if grep -q persistent /proc/cmdline; then
-        i=0
-        # We love udev and the kernel!
-        while [ "$i" -lt 300 ]; do
-            cowdevice=$(find_cow_device) 
-            if [ -b "$cowdevice" ]; then
-                mount -t $(get_fstype "$cowdevice") -o rw "$cowdevice" /cow || panic "Can not mount $cowdevice on /cow"
-                break
-            fi
-            sleep 0.1
-            i=$(( $i + 1 ))
+    cowdevice="tmpfs"
+    cow_fstype="tmpfs"
+
+    # Looking for "${root_persistence}" device or file
+    if [ -n "${PERSISTENT}" ]; then
+        cowprobe=$(find_cow_device "${root_persistence}")
+        if [ -b "${cowprobe}" ]; then
+            cowdevice=${cowprobe}
+            cow_fstype=$(get_fstype "${cowprobe}")
+        else
+            [ "$quiet" != "y" ] && log_warning_msg "Unable to find the persistent medium"
+        fi
+    fi
+
+    mount ${cowdevice} -t ${cow_fstype} -o rw /cow || panic "Can not mount $cowdevice on /cow"
+
+    mount -t unionfs -o dirs=/cow=rw:$rofsstring unionfs "$rootmnt" || panic "Unionfs mount failed"
+
+    # Adding other custom mounts
+    if [ -n "${PERSISTENT}" ]; then
+        # directly mount /home
+        # FIXME: add a custom mounts configurable system
+        homecow=$(find_cow_device "${home_persistence}" )
+        if [ -b "${homecow}" ]; then
+            mount -t $(get_fstype "${homecow}") -o rw "${homecow}" "${rootmnt}/home"
+            export HOMEMOUNTED=1 # used to proper calculate free space in do_snap_copy()
+        else
+            [ "$quiet" != "y" ] && log_warning_msg "Unable to find the persistent home medium"
+        fi
+        # Look for other snapshots to copy in
+        try_snap "${root_snapshot_label}" "${rootmnt}" "ROOT"
+        try_snap "${home_snapshot_label}" "${rootmnt}/home" "HOME"
+    fi
+
+    if [ -n "${SHOWMOUNTS}" ]; then
+        for d in ${rofslist}; do
+            mkdir -p "${rootmnt}/casper/${d##*/}"
+            case d in
+                *.dir) # do nothing # mount -o bind "${d}" "${rootmnt}/casper/${d##*/}"
+                    ;;
+                *) mount -o move "${d}" "${rootmnt}/casper/${d##*/}"
+                    ;;
+            esac
         done
-    else
-        mount -t tmpfs tmpfs /cow
+        # shows cow fs on /cow for use by casper-snapshot
+        mkdir -p "${rootmnt}/cow"
+        mount -o bind /cow "${rootmnt}/cow"
     fi
-    
-    mount -t unionfs -o dirs=/cow=rw:$rofsstring unionfs "$rootmnt"
 
     # move the first mount; no head in busybox-initramfs
     for d in $(mount -t squashfs | cut -d\  -f 3); do
@@ -241,67 +391,78 @@ setup_unionfs() {
         mount -o move "${d}" "${rootmnt}/rofs"
         break
     done
+}
 
-    if grep -q showmounts /proc/cmdline; then
-        for d in $(mount -t squashfs | cut -d\  -f 3); do
-            mkdir -p "${rootmnt}/casper/${d##*/}"
-            mount -o move "${d}" "${rootmnt}/casper/${d##*/}"
-        done
+check_dev ()
+{
+    sysdev="${1}"
+    devname="${2}"
+    if [ -z "${devname}" ]; then
+        devname=$(sys2dev "${sysdev}")
+    fi
 
-        mkdir -p "$rootmnt/cow"
-        mount -o bind /cow "$rootmnt/cow"
+    if [ -n "${LIVEMEDIA_OFFSET}" ]; then
+        loopdevname=$(setup_loop "${devname}" "loop" "/sys/block/loop*" "${LIVEMEDIA_OFFSET}")
+        devname="${loopdevname}" 
     fi
 
-}
+    fstype=$(get_fstype "${devname}")
+    if is_supported_fs ${fstype}; then
+        mount -t ${fstype} -o ro "${devname}" $mountpoint || continue
+        if is_casper_path $mountpoint; then
+            echo $mountpoint
+            return 0
+        else
+            umount $mountpoint
+        fi
+    fi
 
-is_usb_device() {
-    sysfs_path="${1#/sys}"
-    if /lib/udev/path_id "${sysfs_path}" | grep -E -q "ID_PATH=(usb|pci-[^-]*-usb)"; then
-        return 0
+    if [ -n "${LIVEMEDIA_OFFSET}" ]; then
+        losetup -d "${loopdevname}"
     fi
     return 1
 }
 
 find_livefs() {
-       mounted=
-        for sysblock in $(echo /sys/block/* | tr ' ' '\n' | grep -v loop | grep -v ram); do
-            devname=$(sys2dev "${sysblock}")
-            fstype=$(get_fstype "${devname}")
-            if /lib/udev/cdrom_id ${devname} > /dev/null; then
-                mount -t ${fstype} -o ro "$devname" $mountpoint || continue
-                if is_casper_path $mountpoint; then
-                    echo $mountpoint
-                    return
-                else
-                    umount $mountpoint
-                fi
-            elif is_usb_device "$sysblock"; then
-                for dev in $(subdevices "${sysblock}"); do
-                    devname=$(sys2dev "${dev}")
-                    fstype=$(get_fstype "${devname}")
-                    case ${fstype} in
-                        vfat|iso9660|udf)
-                            mount -t ${fstype} -o ro "${devname}" $mountpoint || continue
-                            if is_casper_path $mountpoint; then
-                                echo $mountpoint
-                                return
-                            else
-                                umount $mountpoint
-                            fi
-                            ;;
-                    esac
-                done
-           elif [ "${fstype}" = "squashfs" ]; then
-
-                # This is an ugly hack situation, the block device has
-                # a squashfs image directly on it.  It's hopefully
-                # casper, so take it and run with it.
-
-                ln -s "${devname}" "${devname}.${fstype}"
-                echo "${devname}.${fstype}"
-                return
+    timeout="${1}"
+    # first look at the one specified in the command line
+    if [ ! -z "${LIVEMEDIA}" ]; then
+        if check_dev "null" "${LIVEMEDIA}"; then
+            return 0
+        fi
+    fi
+    # don't start autodetection before timeout has expired
+    if [ -n "${LIVEMEDIA_TIMEOUT}" ]; then
+        if [ "${timeout}" -lt "${LIVEMEDIA_TIMEOUT}" ]; then
+            return 1
+        fi
+    fi
+    # or do the scan of block devices
+    for sysblock in $(echo /sys/block/* | tr ' ' '\n' | grep -v loop | grep -v ram); do
+        devname=$(sys2dev "${sysblock}")
+        fstype=$(get_fstype "${devname}")
+        if /lib/udev/cdrom_id ${devname} > /dev/null; then
+            if check_dev "null" "${devname}" ; then
+                return 0
             fi
-        done
+        elif is_nice_device "${sysblock}" ; then
+            for dev in $(subdevices "${sysblock}"); do
+                if check_dev "${dev}" ; then
+                    return 0
+                fi
+            done
+        elif [ "${fstype}" = "squashfs" -o \
+                "${fstype}" = "ext3" -o \
+                "${fstype}" = "ext2" ]; then
+            # This is an ugly hack situation, the block device has
+            # an image directly on it.  It's hopefully
+            # casper, so take it and run with it.
+            ln -s "${devname}" "${devname}.${fstype}"
+            echo "${devname}.${fstype}"
+            return 0
+        fi
+    done
+    return 1
 }
 
 pulsate() {
@@ -321,7 +482,7 @@ mountroot() {
     exec 7>&2
     exec > casper.log
     exec 2>&1
-    
+
     set_usplash_timeout
     [ "$quiet" != "y" ] && log_begin_msg "Running /scripts/casper-premount"
     pulsate
@@ -333,18 +494,40 @@ mountroot() {
 
     set_usplash_timeout
 
-    for i in 0 1 2 3 4 5 6 7 8 9 a b c d e f 10 11 12 13; do
-        livefs_root=$(find_livefs)
-        if [ "${livefs_root}" ]; then
-            break
+    if [ ! -z "${NETBOOT}" ]; then
+        if do_netmount ; then
+            livefs_root="${mountpoint}"
+        else
+            panic "Unable to find a the network rootfs live file system"
         fi
-        sleep 1
-    done
-    if [ "$?" -gt 0 ]; then
+    else
+        # Scan local devices for the image
+        for i in 0 1 2 3 4 5 6 7 8 9 a b c d e f 10 11 12 13; do
+            livefs_root=$(find_livefs $i)
+            if [ "${livefs_root}" ]; then
+                break
+            fi
+            sleep 1
+        done
+    fi
+
+    if [ -z "${livefs_root}" ]; then
         panic "Unable to find a medium containing a live file system"
     fi
-    
-    mount_images_in_directory "$livefs_root" "$rootmnt"
+
+    if [ "${TORAM}" ]; then
+        live_dest="ram"
+    elif [ "${TODISK}" ]; then
+        live_dest="${TODISK}"
+    fi
+    if [ "${live_dest}" ]; then
+        log_begin_msg "Copying live_media to ${live_dest}"
+        copy_live_to "${livefs_root}" "${live_dest}"
+        log_end_msg
+    fi
+
+    mount_images_in_directory "${livefs_root}" "${rootmnt}"
+
     log_end_msg
 
     maybe_break casper-bottom
index f7254e8..4fe9378 100755 (executable)
@@ -41,7 +41,11 @@ set passwd/user-uid
 EOF
 
 if [ -f /root/etc/sudoers ]; then
-    grep -q '^%admin' /root/etc/sudoers && sed -i -e '/^%admin/s/ALL$/NOPASSWD: ALL/' /root/etc/sudoers || echo '%admin  ALL=(ALL) NOPASSWD: ALL' >> /root/etc/sudoers
+    if [ "${BUILD_SYSTEM}" = "Ubuntu" ]; then
+        grep -q '^%admin' /root/etc/sudoers && sed -i -e '/^%admin/s/ALL$/NOPASSWD: ALL/' /root/etc/sudoers || echo '%admin  ALL=(ALL) NOPASSWD: ALL' >> /root/etc/sudoers
+    elif [ "${BUILD_SYSTEM}" = "Debian" ]; then
+               echo "${USERNAME}  ALL=(ALL) NOPASSWD: ALL" >> /root/etc/sudoers
+    fi
 fi
 
 # XXX - awful hack to stop xscreensaver locking the screen (#7150)
index f9f76b5..3ee3ef0 100755 (executable)
@@ -21,36 +21,43 @@ esac
 log_begin_msg "$DESCRIPTION"
 
 if [ -e /root/etc/default/locale ]; then
-       grep_file=/root/etc/default/locale
-       locale=$(grep 'LANG=' ${grep_file} | sed s/'LANG='// | tr -d '"' ) 
+    grep_file=/root/etc/default/locale
 elif [ -e /root/etc/environment ]; then # Old locales policy
-       grep_file=/root/etc/environment
+    grep_file=/root/etc/environment
+fi
+
+if [ -n "${grep_file}" ]; then
+    # use rootfs configured locale
+    locale=$(grep -s 'LANG=' ${grep_file} | sed s/'LANG='// | tr -d '"' )
+else
+    grep_file=/root/etc/default/locale
 fi
 
 # commandline
 for x in $(cat /proc/cmdline); do
-       case $x in
-               debian-installer/locale=*)
+    case $x in
+        debian-installer/locale=*)
                        locale=${x#debian-installer/locale=}
                        set_locale="true"
                        ;;
                locale=*)
                        locale=${x#locale=}
                        set_locale="true"
-                       ;;
-       esac
+            ;;
+    esac
 done
 
 if [ -z "${locale}" ]; then
-       # Set a default one
-       locale=en_US.UTF-8
-       set_locale="true"
+    # Set a default one
+    locale=en_US.UTF-8
+    set_locale="true"
 fi
 
 if [ "${set_locale}" ]; then
-       LANG=$(grep "^${locale}" /root/usr/share/i18n/SUPPORTED | grep UTF-8 |sed -e 's, .*,,' -e q)
-       printf 'LANG="%s"\n' "${LANG}" >> "${grep_file}" 
-       chroot /root /usr/sbin/locale-gen "${LANG}"
+    LANG=$(grep "^${locale}" /root/usr/share/i18n/SUPPORTED | grep UTF-8 |sed -e 's, .*,,' -e q)
+    printf 'LANG="%s"\n' "${LANG}" >> "${grep_file}"
+    printf '%s UTF-8\n' "${LANG}" > /root/etc/locale.gen
+    chroot /root /usr/sbin/locale-gen "${LANG}"
 fi
 
 log_end_msg
index c8cc93d..ef90115 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/sh
 
 PREREQ=""
-DESCRIPTION="Setting up keyboard..."
+DESCRIPTION="Setting up console keyboard..."
 
 . /scripts/casper-functions
 
index 3916f41..b6e7550 100755 (executable)
@@ -42,6 +42,11 @@ done
 mount -n -o bind /sys /root/sys
 mount -n -o bind /proc /root/proc
 
+if [ -n "${XDEBCONF}" -a -x /root/usr/sbin/xdebconfigurator ]; then
+    # xdebconfigurator
+    chroot /root /usr/sbin/xdebconfigurator
+fi
+
 chroot /root debconf-communicate -fnoninteractive casper > /dev/null <<EOF
 set xserver-xorg/autodetect_keyboard true
 fset xserver-xorg/autodetect_keyboard seen true
index d879d8d..39c0f22 100755 (executable)
@@ -22,7 +22,9 @@ log_begin_msg "$DESCRIPTION"
 
 gnome_screensaver_version=$(chroot /root dpkg-query -W --showformat='${Version}' gnome-screensaver 2>/dev/null) || gnome_screensaver_version=""
 if [ -n "$gnome_screensaver_version" ]; then
+    # Support legacy gconf value
     chroot /root sudo -u "$USERNAME" gconftool-2 -t bool -s /apps/gnome-screensaver/lock false
+    chroot /root sudo -u "$USERNAME" gconftool-2 -t bool -s /apps/gnome-screensaver/lock_enabled false
 fi
 
 log_end_msg
index a17a02c..1b732d3 100755 (executable)
@@ -21,27 +21,82 @@ esac
 
 log_begin_msg "$DESCRIPTION"
 
+if [ "${STATICIP}" = "frommedia" -a -e  "$IFFILE" ] ; then
+    # will use existent /etc/network/interfaces
+    log_end_msg
+    exit 0
+fi
+
 cat > "$IFFILE" <<EOF
 auto lo
 iface lo inet loopback
 
 EOF
 
-udevtrigger -Bpci -Iclass="0x02*"
+udevtrigger
 udevsettle
 
-for interface in /sys/class/net/eth* /sys/class/net/ath* /sys/class/net/wlan*; do
-    [ -e $interface ] || continue
-    i="$(basename $interface)"
-    cat >> "$IFFILE" <<EOF
+if [ -z "${NETBOOT}" -a -n "${STATICIP}" -a "${STATICIP}" != "frommedia" ]; then
+    parsed=$(echo "${STATICIP}" | sed -e 's/:/ /g')
+    for ifline in ${parsed}; do
+        ifname="$(echo ${ifline} | cut -f1 -d ',')"
+        ifaddress="$(echo ${ifline} | cut -f2 -d ',')"
+        ifnetmask="$(echo ${ifline} | cut -f3 -d ',')"
+        ifgateway="$(echo ${ifline} | cut -f4 -d ',')"
+        cat >> "$IFFILE" <<EOF
+auto ${ifname}
+iface ${ifname} inet static
+    address ${ifaddress}
+    netmask ${ifnetmask}
+    gateway ${ifgateway}
+
+EOF
+    done
+else
+    if [ -z "${NETBOOT}" ]; then
+        # default, dhcp assigned
+        method="dhcp"
+    else
+        # make sure that the preconfigured interface would not get reassigned by dhcp
+        # on startup by ifup script - otherwise our root fs might be disconnected!
+        method="manual"
+    fi
+    # iterate the physical interfaces and add them to the interfaces list
+    for interface in /sys/class/net/eth* /sys/class/net/ath* /sys/class/net/wlan*; do
+        [ -e $interface ] || continue
+        i="$(basename $interface)"
+        cat >> "$IFFILE" <<EOF
 auto $i
-iface $i inet dhcp
+iface $i inet $method
 
 EOF
-done
+    done
+    if [ ! -f /root/etc/resolv.conf -a -f /netboot.config ] ; then
+        # create a resolv.conf if it is not present
+        cp /netboot.config /root/var/log/netboot.config
+        rc_search=$(cat netboot.config | awk '/domain/{print $3}')
+        rc_server0=$(cat netboot.config | awk '/dns0/{print $5}')
+        rc_server1=$(cat netboot.config | awk '/dns0/{print $8}')
+        rc_server0="nameserver ${rc_server0}"
+        if [ "${rc_server1}" = "0.0.0.0" ]; then
+            rc_server1=""
+        else
+            rc_server1="nameserver ${rc_server1}"
+        fi
+        cat > /root/etc/resolv.conf <<EOF
+# /etc/resolv.conf
+# Autogenerated by casper
+search ${rc_search}
+domain ${rc_search}
+${rc_server0}
+${rc_server1}
+EOF
+        cat /root/etc/resolv.conf >> /root/var/log/netboot.config
+    fi
+fi
 
 for i in eth0 eth1 eth2 ath0 wlan0; do
-    [ ! -e /sys/class/net/$i ] || continue
+    grep -q "iface $i" $IFFILE && continue
     cat >> "$IFFILE" <<EOF
 auto $i
 iface $i inet dhcp
index 10b86a2..2461c25 100755 (executable)
@@ -20,7 +20,15 @@ esac
 
 log_begin_msg "$DESCRIPTION"
 
-rm -f /root/etc/xdg/autostart/update-notifier.desktop
+# For GNOME, we divert away apt-check to avoid a regular 'apt-get update'
+# equivalent in the live session. We want to run update-notifier for crash
+# report handling.
+chroot /root dpkg-divert --add --rename --quiet \
+       /usr/lib/update-notifier/apt-check
+ln -s /bin/true /root/usr/lib/update-notifier/apt-check
+
+# For KDE, adept_notifier's only useful function at the moment is an
+# 'apt-get update' equivalent, so we disable it entirely.
 rm -f /root/usr/share/autostart/adept_notifier_auto.desktop
 
 log_end_msg
diff --git a/scripts/casper-helpers b/scripts/casper-helpers
new file mode 100644 (file)
index 0000000..8402d93
--- /dev/null
@@ -0,0 +1,197 @@
+## Casper helper functions, used by casper on boot and by casper-snapshot
+
+if [ "${BUILD_SYSTEM}" = "Ubuntu" ]; then
+    MP_QUIET="-Q"
+elif [ "${BUILD_SYSTEM}" = "Debian" ]; then
+    MP_QUIET="-q"
+else
+    MP_QUIET=""
+fi
+
+if [ ! -x "/bin/fstype" ]; then
+    # klibc not in path -> not in initramfs
+    export PATH="${PATH}:/usr/lib/klibc/bin"
+fi
+
+sys2dev() {
+    sysdev=${1#/sys}
+    echo "/dev/$(udevinfo -q name -p ${sysdev} 2>/dev/null|| echo ${sysdev##*/})"
+}
+
+subdevices() {
+    sysblock=$1
+    r=""
+    for dev in "${sysblock}" "${sysblock}"/*; do
+        if [ -e "${dev}/dev" ]; then
+            r="${r} ${dev}"
+        fi
+    done
+    echo ${r}
+}
+
+get_fstype() {
+    local FSTYPE
+    local FSSIZE
+    eval $(fstype < $1)
+    if [ "$FSTYPE" != "unknown" ]; then
+        echo $FSTYPE
+        return 0
+    fi
+    /lib/udev/vol_id -t $1 2>/dev/null
+}
+
+where_is_mounted() {
+    device=$1
+    if grep -q "^$device " /proc/mounts; then
+        grep "^$device " /proc/mounts | read d mountpoint rest
+        echo $mountpoint
+        return 0
+    fi
+    return 1
+}
+
+lastline() {
+    while read lines ; do
+        line=${lines}
+    done
+    echo "${line}"
+}
+
+base_path ()
+{
+    testpath="${1}"
+    mounts="$(awk '{print $2}' /proc/mounts)"
+    testpath="$(busybox realpath ${testpath})"
+
+    while true ; do
+        if echo "${mounts}" | grep -qs "^${testpath}" ; then
+            set -- `echo "${mounts}" | grep "^${testpath}" | lastline`
+            echo ${1}
+            break
+        else
+            testpath=`dirname $testpath`
+        fi
+    done
+}
+
+fs_size ()
+{
+    # Returns used/free fs kbytes + 5% more
+    # You could pass a block device as $1 or the mount point as $2
+
+    dev="${1}"
+    mountp="${2}"
+    used="${3}"
+
+    if [ -z "${mountp}" ]; then
+        mountp=$(where_is_mounted "${dev}")
+        if [ "$?" -gt 0 ]; then
+            mountp="/mnt/tmp_fs_size"
+            mkdir -p "${mountp}"
+            mount -t $(get_fstype "${dev}") -o ro "${dev}" "${mountp}"
+            doumount=1
+        fi
+    fi
+
+    if [ "${used}" = "used" ]; then
+        size=$(du -ks ${mountp} | cut -f1)
+        size=$(expr ${size} + ${size} / 20 ) # FIXME: 5% more to be sure
+    else
+        # free space
+        size="$(df -k | grep -s ${mountp} | awk '{print $4}')"
+    fi
+
+    if [ -n "${doumount}" ]; then
+        umount "${mountp}"
+        rmdir "${mountp}"
+    fi
+    echo "${size}"
+}
+
+setup_loop() {
+    local fspath=$1
+    local module=$2
+    local pattern=$3
+    local offset=$4
+
+    modprobe ${MP_QUIET} -b "$module"
+    udevsettle
+
+    for loopdev in $pattern; do
+        if [ "$(cat $loopdev/size)" -eq 0 ]; then
+            dev=$(sys2dev "${loopdev}")
+            if [ -n "$offset" ]; then
+                losetup -o "$offset" "$dev" "$fspath"
+            else
+                losetup "$dev" "$fspath"
+            fi
+            echo "$dev"
+            return 0
+        fi
+    done
+    panic "No loop devices available"
+}
+
+try_mount ()
+{
+    dev="${1}"
+    mountp="${2}"
+    opts="${3}"
+
+    if where_is_mounted ${dev} > /dev/null; then
+        mount -o remount,"${opts}" ${dev} $(where_is_mounted ${dev}) || panic "Remounting failed"
+        mount -o bind $(where_is_mounted ${dev}) ${mountp} || panic "Cannot bind-mount"
+    else
+        mount -t $(get_fstype "${dev}") -o "${opts}" "${dev}" "${mountp}" || panic "Cannot mount ${dev} on ${mountp}"
+    fi
+}
+
+find_cow_device() {
+    pers_label="${1}"
+    cow_backing="/${pers_label}-backing"
+    for sysblock in $(echo /sys/block/* | tr ' ' '\n' | grep -v loop); do
+        for dev in $(subdevices "${sysblock}"); do
+            devname=$(sys2dev "${dev}")
+            if [ "$(/lib/udev/vol_id -l $devname 2>/dev/null)" = "${pers_label}" ]; then
+                echo "$devname"
+                return
+            elif [ "$(get_fstype ${devname})" = "vfat" ]; then # FIXME: all supported block devices should be scanned
+                mkdir -p "${cow_backing}"
+                try_mount "${devname}" "${cow_backing}" "rw"
+                if [ -e "${cow_backing}/${pers_label}" ]; then
+                    echo $(setup_loop "${cow_backing}/${pers_label}" "loop" "/sys/block/loop*")
+                    return 0
+                else
+                    umount ${cow_backing}
+                fi
+            fi
+        done
+    done
+}
+
+find_files()
+# return the first of $filenames found on vfat and ext2 devices
+# FIXME: merge with above function
+{
+    filenames="${1}"
+    snap_backing="/snap-backing"
+    for sysblock in $(echo /sys/block/* | tr ' ' '\n' | grep -v loop); do
+        for dev in $(subdevices "${sysblock}"); do
+            devname=$(sys2dev "${dev}")
+            devfstype="$(get_fstype ${devname})"
+            if [ "${devfstype}" = "vfat" ] ||  [ "${devfstype}" = "ext2" ] ; then # FIXME: all supported block devices should be scanned
+                mkdir -p "${snap_backing}"
+                try_mount "${devname}" "${snap_backing}" "ro"
+                for filename in ${filenames}; do
+                    if [ -e "${snap_backing}/${filename}" ]; then
+                        echo "${devname} ${snap_backing} ${filename}"
+                        return 0
+                    fi
+                done
+                umount ${snap_backing}
+            fi
+        done
+    done
+}
+
+